=== debian/changelog ===
pgagroal (2.0.1-2) unstable; urgency=medium

  * debian/tests/connect: Test pgagroal.service for now, .socket has problems.

 -- Christoph Berg <myon@debian.org>  Mon, 23 Feb 2026 13:47:41 +0100

pgagroal (2.0.1-1) unstable; urgency=medium

  * New upstream version 2.0.1.
  * debian/tests/connect: Use system PG cluster for tests.

 -- Christoph Berg <myon@debian.org>  Wed, 18 Feb 2026 14:25:00 +0100

pgagroal (2.0.0-3) unstable; urgency=medium

  * Unsupport 32-bit architectures. (Closes: #1127845,
    https://github.com/pgagroal/pgagroal/issues/718)

 -- Christoph Berg <myon@debian.org>  Tue, 17 Feb 2026 11:54:36 +0100

pgagroal (2.0.0-2) unstable; urgency=medium

  * Link libraries dynamically.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Feb 2026 19:00:33 +0100
