=== debian/control ===
Source: pgagroal
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit,
 cmake (>= 3.14.0),
 libbz2-dev,
 libcjson-dev,
 libev-dev,
 liblz4-dev,
 libssl-dev,
 libsystemd-dev,
 liburing-dev,
 libzstd-dev,
 postgresql-all,
 python3-docutils,
 zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/agroal/pgagroal
Vcs-Browser: https://salsa.debian.org/postgresql/pgagroal
Vcs-Git: https://salsa.debian.org/postgresql/pgagroal.git

Package: pgagroal
Architecture: any
Depends:
 postgresql-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: High-performance connection pool for PostgreSQL
 pgagroal is a high-performance protocol-native connection pool for PostgreSQL.
 .
 Pronounced: p-g-a-gro-al, named after Agroal in Portugal.
 .
 Features:
  * High performance
  * Connection pool
  * Limit connections for users and databases
  * Prefill support
  * Remove idle connections
  * Perform connection validation
  * Enable / disable database access
  * Graceful / fast shutdown
  * Prometheus support
  * Grafana 8 dashboard
  * Remote management
  * Authentication query support
  * Failover support
  * Transport Layer Security (TLS) v1.2+ support
  * Daemon mode
  * User vault
