=== debian/tests/control ===
Depends:
 postgresql,
 procps,
 @,
Tests:
 connect,
Restrictions:
 allow-stderr,
 needs-root,
